#include "functions.h"
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>

void loadFunction(float *a, int size){
    float x = 10.0;
    for(size_t i = 0; i < size; ++i)
    {
        a[i] = (float)((double)rand()/(double)(RAND_MAX/x));
    }
}

static inline uint64_t get_cycles()
{
  uint64_t t;
  __asm volatile ("rdtsc" : "=A"(t));
  return t;
}


void printFunction(float *a,int size){
    for(size_t i = 0; i < size; ++i)
    {
        printf("%zu %f\n",i,a[i]);
    }
}
int compareOutput(float *a,float *b,int size){
    for(size_t i = 0; i < size; ++i)
    {
        float compare = a[i]-b[i];
        if(!(compare > -0.005  && compare < 0.005 ))
        {
            return 0;
        }
    }
    return 1;
}

int main (int argc, char const *argv[])
{
    int size = 1<<10;
    
    float * resulta;
    float * resultb;
    float * a1;
    float * b1;
    float * a2;
    float * b2;
    
    posix_memalign((void **)&a1,16,sizeof(float)*size);
    posix_memalign((void **)&b1,16,sizeof(float)*size);
    posix_memalign((void **)&a2,16,sizeof(float)*size);
    posix_memalign((void **)&b2,16,sizeof(float)*size);
    
    posix_memalign((void **)&resulta,16,sizeof(float)*size);
    posix_memalign((void **)&resultb,16,sizeof(float)*size);
    
    loadFunction(a1,size);
    loadFunction(b1,size);
    
    memcpy( a2, a1, size * sizeof(float) );
    memcpy( b2, b1, size * sizeof(float) );
    
    for(size_t i = 0; i < 10; ++i)
    {
        int t1;
        t1 = get_cycles();
        calculateFunction(a1,b1,resulta,size);
        int t2 = get_cycles();
        sseFunction(a2,b2,resultb,size);
        int t3 = get_cycles();
        
        printf("%d %d ",t2-t1,t3-t2);
        if(compareOutput(resulta,resultb,size))
        {
            printf("CORRECT\n");
        }else{
            printf("INCORRECT\n");
        }
    }
    return 0;
}