#include "functions.h"
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>

void loadFunction(float *a, int size){
    float x = 10.0;
    for(size_t i = 0; i < size; ++i)
    {
        a[i] = (float)((double)rand()/(double)(RAND_MAX/x));
    }
}

static inline uint64_t get_cycles()
{
  uint64_t t;
  __asm volatile ("rdtsc" : "=A"(t));
  return t;
}


void printFunction(float *a,int size){
    for(size_t i = 0; i < size; ++i)
    {
        printf("%zu %f\n",i,a[i]);
    }
}
int compareOutput(float *a,float *b,int size){
    for(size_t i = 0; i < size; ++i)
    {
        float compare = a[i]-b[i];
        if(!(compare > -0.005  && compare < 0.005 ))
        {
            return 0;
        }
    }
    return 1;
}

int main (int argc, char const *argv[])
{
    int size = 1 <<10;
    
    float * x1,*y1,*z1,*w1;
    float * x2,*y2,*z2,*w2;
    
    posix_memalign((void **)&x1,16,sizeof(float)*size);
    posix_memalign((void **)&y1,16,sizeof(float)*size);
    posix_memalign((void **)&z1,16,sizeof(float)*size);
    posix_memalign((void **)&w1,16,sizeof(float)*size);
    
    posix_memalign((void **)&x2,16,sizeof(float)*size);
    posix_memalign((void **)&y2,16,sizeof(float)*size);
    posix_memalign((void **)&z2,16,sizeof(float)*size);
    posix_memalign((void **)&w2,16,sizeof(float)*size);
        
    for(size_t i = 0; i < 10; ++i)
    {
        loadFunction(x1,size);
        loadFunction(y1,size);
        loadFunction(z1,size);
        loadFunction(w1,size);
    
        memcpy( x2, x1, size * sizeof(float) );
        memcpy( y2, y1, size * sizeof(float) );
        memcpy( z2, z1, size * sizeof(float) );
        memcpy( w2, w1, size * sizeof(float) );
        
        int t1;
        t1 = get_cycles();
        calculateFunction(x1,y1,z1,w1,size);
        int t2 = get_cycles();
        sseFunction(x2,y2,z2,w2,size);
        int t3 = get_cycles();
        printf("%d %d ",t2-t1,t3-t2);
        
        if(compareOutput(x1,x2,size) && compareOutput(y1,y2,size) &&
        compareOutput(z1,z2,size) && compareOutput(w1,w2,size))
        {
            printf("CORRECT\n");
        }else{
            printf("INCORRECT\n");
        }
    }
    return 0;
}