//count occurrences of a specific colour in a 24 bit per pixel RGB image
//hints: 16 pixels form a nice block to work with.
//       Also, we promise that the size is divisible by 48.
//note: you have to violate strict aliasing for this assignment, but this specific case (aliasing __m128i with something) must be supported by all compilers that support SSE intrinsics.
#include "functions.h"
#include "xmmintrin.h"
#include "smmintrin.h"

int calculateFunction(uint8_t* image, uint32_t find, int size) {
    int count = 0;
    for(size_t i = 0; i < size; i += 3)
    {
        // gather 3 bytes for the pixel
        uint32_t pixel = image[i] | (image[i + 1] << 8) | (image[i + 2] << 16);
        if (pixel == find)
            count++;
    }
    return count;
}

int sseFunction(uint8_t* image, uint32_t find, int size) {
    //replace with the total count this is added to suppress compiler warnings
    return 0;
}
